#!/usr/bin/perl
require("/etc/re_config.pl");
push(@INC,$modules_dir);
require("format_calls_lib.pl");
require("sublist.pl");


my $html_start="<html>\n<head></head><body><pre>\n";
my $addr_line_format="<a href=\"javascript:window.open('/cgi-bin/show_call.pl?func=%s#%s','%scall','toolbar=no,width=600,height=800,resizable=yes,scrollbars=yes');void('');\">%s</a>";
my $call_line_format="<a href=\"javascript:window.open('/cgi-bin/show_call.pl?func=%s','call','toolbar=no,width=600,height=800,resizable=yes,scrollbars=yes');void('');\"><font color=%s>%s</font></a>";
my $jmp_line_format="%s %s";
my $html_end="</pre></body>\n<html>\n";

my $end_points;
my $end_points_n=0;
sub read_endpoints
{
	my (@end_points_files)=@_;

	foreach my $end_points_file (@end_points_files)
	{
		if(!open(END_POINTS_FILE,"<$end_points_file"))
		{
			return;
		}
		while(<END_POINTS_FILE>)
		{
			if(/^x /)
			{
				$end_points[$end_points_n][0]="except";
			}else{
				$end_points[$end_points_n][0]="endpoint";
			}
			$end_points[$end_points_n][1]=$_;
			$end_points[$end_points_n][1]=~ s/^x //;
			chomp($end_points[$end_points_n][1]);
			$end_points_n++;
		}
	}
}

sub is_except
{
	my ($callname)=@_;
	for($end_points_i=0;$end_points_i<$end_points_n;$end_points_i++)
	{
		if($end_points[$end_points_i][0] eq "except" && $end_points[$end_points_i][1] eq $callname)
		{
			return 1;
		}
	}
	return 0;
}

sub is_endpoints
{
	my ($callname)=@_;
	for($end_points_i=0;$end_points_i<$end_points_n;$end_points_i++)
	{
		if($end_points[$end_points_i][0] eq "endpoint" && $end_points[$end_points_i][1] eq $callname)
		{
			return 1;
		}
	}
	return 0;
}

use Getopt::Std;
getopt('m:');
my $max_level=3;
if($opt_m)
{
	$max_level=$opt_m;
}

sub check_loop
{
	my ($current_call_name,@call_stack)=@_;

	foreach my $callname (@call_stack)
	{
		if($callname eq $current_call_name)
		{
			return 1;
		}
	}
	return 0;
}

sub get_call
{
	my ($indent_level,$input_file,@call_stack)=@_;
	my $indent_str=get_indent_str($indent_level);

	if(!-f $input_file)
	{
		return;
	}
	my $current_call_name=$input_file;
	$current_call_name=~s/\.call$//;

	if($indent_level>$max_level)
	{
		return;
	}

	if(check_loop($current_call_name,@call_stack))
	{
		print STDERR "loop found [$current_call_name]\n";
		return;
	}
	my $call_num=$#call_stack;
	$call_stack[$call_num+1]=$current_call_name;

	local *INPUT_FILE;

	open(INPUT_FILE,"<$input_file") || die "unable to open $input_file\n";
	my $calls;
	my $calls_n=0;
	$calls_n=0;
	while (<INPUT_FILE>) {
		my $addr=get_addr($_);
		my $op=get_op($_);
		my $src=get_src($_);
		my $dst=get_dst($_);
		if($op =~ /^call/ || $op=~/^j/)
		{
			$calls{$input_file}[$calls_n][0]=$addr;
			$calls{$input_file}[$calls_n][1]=$op;
			$calls{$input_file}[$calls_n][2]=$src;
			$calls_n++;
		}
	}
	close(INPUT_FILE);

	my $calls_i;
	for($calls_i=0;$calls_i<$calls_n;$calls_i++)
	{
		my $addr=$calls{$input_file}[$calls_i][0];
		my $op=$calls{$input_file}[$calls_i][1];
		my $src=$calls{$input_file}[$calls_i][2];
		#print STDERR "$indent_str$input_file:$addr $src\n";
		my $subst_src=substitute_list("",$src,0);
		my $color_code="#0000ff";
		if($subst_src eq $src)
		{
			$color_code="#ff0000";
		}
		my $addr_html_out_str=sprintf $addr_line_format,$current_call_name,$addr,$current_call_name,$addr;
		if(0 && $op=~/^j/)
		{
			my $jmp_html_out_str=sprintf $jmp_line_format,$op,$src;
			print OUTPUT_FILE "$indent_str $addr_html_out_str/ $jmp_html_out_str\n";
		}
		if($op=~ /^call/ && !is_except($src) && !is_except($subst_src))
		{
			my $call_html_out_str=sprintf $call_line_format,$src,$color_code,$subst_src;
			print OUTPUT_FILE "$indent_str $addr_html_out_str/ $call_html_out_str\n";
		}

		if($op=~/^call/ && !is_endpoints($src) && !is_endpoints($subst_src))
		{
			my $sub_call_file_name=$src;
			$sub_call_file_name=~ s/$/.call/;
			get_call($indent_level+1,$sub_call_file_name,@call_stack);
		}
	}
}


my $input_file=$ARGV[0];
my $output_file=$input_file;

$output_file=~s/\.call//;
$output_file=~s/$/.tree.html/;
open(OUTPUT_FILE,">$output_file") || die "unable to open $output_file\n";
print OUTPUT_FILE $html_start;
$global_sub_list_file="sub.list";
read_sub_file($global_sub_list_file);

$end_points_file=$input_file;
$end_points_file=~s/\.call//;
$end_points_file=~s/$/.endpoints/;
read_endpoints("endpoints",$end_points_file);

my @call_stack;
get_call(0,$input_file,@call_stack);
print OUTPUT_FILE $html_end;
close(OUTPUT_FILE);
