$sublist'version = sprintf("%d.%02d", q$Revision: 0.01 $ =~ /(\d+)\.(\d+)/);

sub return_sub_list
{
	my ($sub_file_name,$mode)=@_;
	my $comments="";
	my $comments_continue=0;
	my @local_sub_list=();
	my $local_sub_list_n=0;
	my $local_sub_list_str;
	local *SUB_FILE;
	if(!open(SUB_FILE,"<$sub_file_name"))
	{
		print STDERR "unable to open $sub_file_name\n";
		break;
	}
	while(<SUB_FILE>)
	{
		if($comments_continue==0)
		{
			$local_sub_list_str=$_;
			$local_sub_list_str=~s/[ \t\n]*$//;
		}
		if($comments_continue==1 || $_=~ /\#/)
		{
			$cur_comments=$_;
			if($comments_continue==0)
			{
				$cur_comments=~s/^[^#]*\#//g;
			}
			$comments="$comments$cur_comments";
			if($_=~/\\$/)
			{
				$comments=~s/\\$//;
				$comments_continue=1;
				next;
			}
		}
		$comments_continue=0;
		$local_sub_list_str=~s/[ \t]*#.*$//;
		@elements=split(/[ \t]+/,$local_sub_list_str);
		if($#elements==1)
		{
			$elements[1]=~s/\n//g;
			if($debug_sub)
			{
				print "$elements[0]= $elements[1]\n";
			}


			$local_sub_list[$local_sub_list_n][0]="";
			$local_sub_list[$local_sub_list_n][1]="";
			$local_sub_list[$local_sub_list_n][2]=$elements[0];
			$local_sub_list[$local_sub_list_n][3]=$elements[1];
			$local_sub_list[$local_sub_list_n][4]=$comments;
			if($mode)
			{
				$local_sub_list[$local_sub_list_n][2]=~s/\%/\\\%/g;
				$local_sub_list[$local_sub_list_n][2]=~s/\(/\\\(/g;
				$local_sub_list[$local_sub_list_n][2]=~s/\)/\\\)/g;
				$local_sub_list[$local_sub_list_n][2]=~s/\$/\\\$/g;
				$local_sub_list[$local_sub_list_n][3]=~s/\%/\\\%/g;
			}
			$local_sub_list_n++;
		}
		if($#elements==3) {
			$elements[3]=~s/\n//g;
			if($debug_sub)
			{
				print "$elements[0]~$elements[1] $elements[2]=$elements[3]\n";
			}
			$local_sub_list[$local_sub_list_n][0]=$elements[0];
			$local_sub_list[$local_sub_list_n][1]=$elements[1];
			$local_sub_list[$local_sub_list_n][2]=$elements[2];
			$local_sub_list[$local_sub_list_n][3]=$elements[3];
			$local_sub_list[$local_sub_list_n][4]=$comments;
			if($mode)
			{
				$local_sub_list[$local_sub_list_n][2]=~s/\%/\\\%/g;
				$local_sub_list[$local_sub_list_n][2]=~s/\(/\\\(/g;
				$local_sub_list[$local_sub_list_n][2]=~s/\)/\\\)/g;
				$local_sub_list[$local_sub_list_n][2]=~s/\$/\\\$/g;
				$local_sub_list[$local_sub_list_n][3]=~s/\%/\\\%/g;
			}
			$local_sub_list_n++;
		}
		$comments="";
	}
	close(SUB_FILE);
	return ($local_sub_list_n,@local_sub_list);
}

sub get_sub_list
{
	my ($sub_file_name,$mode)=@_;
	my ($ret_sub_n,@ret_sub_array)=return_sub_list($sub_file_name,$mode);
	my $sub_list_i=0;
	for($sub_list_i=0;$sub_list_i<$ret_sub_n;$sub_list_i++)
	{
		$sub_list[$sub_list_n][0]=$ret_sub_array[$sub_list_i][0];
		$sub_list[$sub_list_n][1]=$ret_sub_array[$sub_list_i][1];
		$sub_list[$sub_list_n][2]=$ret_sub_array[$sub_list_i][2];
		$sub_list[$sub_list_n][3]=$ret_sub_array[$sub_list_i][3];
		$sub_list[$sub_list_n][4]=$ret_sub_array[$sub_list_i][4];
		$sub_list_n++;
	}
}

sub read_sub_file
{
	local ($local_sub_file)=@_;
	$sub_list_n=0;
	foreach $sub_file ($global_sub_list_file,$local_sub_file)
	{
		get_sub_list($sub_file,0);
	}
}

sub read_sub_files
{
	local (@local_sub_files)=@_;
	$sub_list_n=0;
	foreach $sub_file (@local_sub_files)
	{
		get_sub_list($sub_file,0);
	}
}

sub dump_sub_list
{
	local (*OUT_FILEHANDLE)=@_;
	for($sub_list_i=0;$sub_list_i<$sub_list_n;$sub_list_i++)
	{
		print OUT_FILEHANDLE "0: $sub_list[$sub_list_i][0] 1: $sub_list[$sub_list_i][1] 2: $sub_list[$sub_list_i][2] 3: $sub_list[$sub_list_i][3]\n";
	}
}

sub get_substitute_from_sublist
{
	my ($addr,$from_str,$sublist_n,@sublist_array)=@_;
	my $sub_list_i;
	for($sub_list_i=0;$sub_list_i<$sublist_n;$sub_list_i++)
	{
		if($from_str eq $sublist_array[$sub_list_i][2])
		{
			return $sublist_array[$sub_list_i][3];
		}
	}
	return "";
}

sub get_substitute
{
	my ($addr,$from_str,$sub_list_n,@sub_list)=@_;
	return get_substitute_from_sublist($addr,$from_str,$sub_list_n,@sub_list);
}

sub escape_for_regex
{
	my ($in_str)=@_;
	$in_str=~s/\%/\\\%/g;
	$in_str=~s/\(/\\\(/g;
	$in_str=~s/\)/\\\)/g;
	$in_str=~s/\$/\\\$/g;
	return $in_str;
}

sub substitute_list
{
	local ($addr,$inputstr,$force)=@_;
	$retstr=$inputstr;
	for($sub_list_i=0;$sub_list_i<$sub_list_n;$sub_list_i++)
	{
		if(
			(
				($sub_list[$sub_list_i][0] eq "" && $sub_list[$sub_list_i][1] eq "") || 
				(hex($sub_list[$sub_list_i][0])<=hex($addr) && hex($addr)<=hex($sub_list[$sub_list_i][1]))
			) 
			&& $sub_list[$sub_list_i][2] ne ""
		)
		{
			my $from_this=$sub_list[$sub_list_i][2];
			$from_this=escape_for_regex($from_this);
			if($sub_list[$sub_list_i][4] && $retstr=~/POS:$from_this/)
			{
				#$retstr=~s/<\!--POS:.*\/\/--\>/<td bgcolor=#f4f2f0><font color=#0f0f00><pre>;$sub_list[$sub_list_i][4]<\/pre><\/font><\/td>/g;
				$retstr="<td bgcolor=#f4f2f0><font color=#0f0f00><pre>;$sub_list[$sub_list_i][4]</pre></font></td>";
			}

			$retstr=~ s/>$from_this</><font color=#ff6666 size=-1>$sub_list[$sub_list_i][3]<\/font></g;

			$retstr=~ s/func=$from_this/FBCDEFGHIJKLMNOPQRSTUVWXYZ_THIS_IS_UNIQUE/g;
			if(!$force)
			{
				#preserve link or file name
				$retstr=~ s/=$from_this/ABCDEFGHIJKLMNOPQRSTUVWXYZ_THIS_IS_UNIQUE/g;
				$retstr=~ s/$from_this\./BBCDEFGHIJKLMNOPQRSTUVWXYZ_THIS_IS_UNIQUE/g;
			}
			$retstr=~ s/$from_this/$sub_list[$sub_list_i][3]/g;
			if(!$force)
			{
				$retstr=~ s/ABCDEFGHIJKLMNOPQRSTUVWXYZ_THIS_IS_UNIQUE/=$from_this/g;
				$retstr=~ s/BBCDEFGHIJKLMNOPQRSTUVWXYZ_THIS_IS_UNIQUE/$from_this./g;
			}
			$retstr=~ s/FBCDEFGHIJKLMNOPQRSTUVWXYZ_THIS_IS_UNIQUE/func=$from_this/g;
		}
	}
	#$retstr=~s/<\!--.*\/\/--\>//g;
	return $retstr;
}

sub restore_list
{
	local ($addr,$inputstr)=@_;
	$retstr=$inputstr;
	for($sub_list_i=0;$sub_list_i<$sub_list_n;$sub_list_i++)
	{
		if(
		($sub_list[$sub_list_i][0]=~"" && $sub_list[$sub_list_i][1]=~"") || ($sub_list[$sub_list_i][0]<=$addr && $addr<=$sub_list[$sub_list_i][1]) &&
		$sub_list[$sub_list_i][2]!~""
		)
		{
				if($sub_list[$sub_list_i][3]=~/^$inputstr$/)
				{
					$retstr=~ s/$sub_list[$sub_list_i][3]/$sub_list[$sub_list_i][2]/g;
				}
		}
	}
	return $retstr;
}

sub get_comment_string
{
	local ($addr,$compstr)=@_;
	$retstr="";
	for($sub_list_i=0;$sub_list_i<$sub_list_n;$sub_list_i++)
	{
		if(
		($sub_list[$sub_list_i][0]=~"" && $sub_list[$sub_list_i][1]=~"") || ($sub_list[$sub_list_i][0]<=$addr && $addr<=$sub_list[$sub_list_i][1]) &&
		$sub_list[$sub_list_i][2]!~""
		)
		{
				if($sub_list[$sub_list_i][2] eq $compstr || $sub_list[$sub_list_i][3] eq $compstr)
				{
					$retstr=$sub_list[$sub_list_i][4];
				}
		}
	}
	return $retstr;
}

sub grep_var
{
	my ($callname,$only_ebp,$only_parameter,$get_global,$in_html)=@_;

	my $input_file="$data_dir/$callname.call";
	my $sub_list_file="$data_dir/$callname.sub.list";
	my $global_sub_list_file="$data_dir/sub.list";

	local *VAR_INPUT_FILE;
	open(VAR_INPUT_FILE,"<$input_file") || die "unable to open $input_file\n";
	my @operand_array;
	my $operand_array_n=0;
	while (<VAR_INPUT_FILE>)
	{
	        my $addr=get_addr($_);
	        my $op=get_op($_);
	        my $src=get_src($_);
	        my $dst=get_dst($_);


		if($op=~/^call/ || $op=~/^j/)
		{
			next;
		}
		if(
			($get_global && $src !~ /%/ && $op!~ /^j/) || 
			(! $get_global && $src =~ /%/)
		)
		{
			if(!$only_ebp || ($only_ebp && $src=~/%ebp/))
			{
				if(!$only_parameter || ($only_parameter && $src=~/\(%ebp\)/ && $src!~/0xf/))
				{
					$operand_array[$operand_array_n]=$src;
					if($only_ebp && $operand_array[$operand_array_n]=~/^0x.\(/)
					{
						$operand_array[$operand_array_n]=~s/^0x/0x0/;
					}
					$operand_array_n++;
				}
			}
		}
		if(
			($get_global && $dst !~ /%/ && $op!~ /^j/) || 
			(! $get_global && $dst =~ /%/)
		)
		{
			if(!$only_ebp || ($only_ebp && $dst=~/%ebp/))
			{
				if(!$only_parameter || ($only_parameter && $dst=~/\(%ebp\)/ && $dst!~/0xf/))
				{
					$operand_array[$operand_array_n]=$dst;
					if($only_ebp && $operand_array[$operand_array_n]=~/^0x.\(/)
					{
						$operand_array[$operand_array_n]=~s/^0x/0x0/;
					}
					$operand_array_n++;
				}
			}
		}	
	}
	close(VAR_INPUT_FILE);
	
#	local $subst_callname=get_substitute("",$callname);
#	
#	if($subst_callname)
#	{
#		print "call: $subst_callname($callname)\n";
#	}else{
#		print "call: $callname\n";
#	}
	if($only_parameter)
	{
		$indent_str="";
	}
	my $last_operand="";
	my $grep_var_ret_str="";

	my ($sublist_n,@sublist_array)=return_sub_list($sub_list_file,0);
	my ($global_sublist_n,@global_sublist_array)=return_sub_list($global_sub_list_file,0);
	foreach my $cur_operand (sort(@operand_array))
	{
		$cur_operand=~s/^\$//g;
		if($only_ebp)
		{
			$cur_operand=~s/^0x0/0x/g;
		}
		if("$cur_operand" ne "$last_operand")
		{
			my $subst_cur_operand=get_substitute_from_sublist("",$cur_operand,$sublist_n,@sublist_array);
			if($subst_cur_operand eq "")
			{
				$subst_cur_operand=get_substitute_from_sublist("",$cur_operand,$global_sublist_n,@global_sublist_array);
			}
			my $cur_operand_str=$cur_operand;
			if($in_html)
			{
				my $real_callname=$callname;
				$real_callname=~s/^.*\///;
				$cur_operand_str=make_target_html("","",$cur_operand,1,1,$real_callname);

				$cur_operand_str=~s/^/<p>/;
			}

			$grep_var_ret_str="$grep_var_ret_str$indent_str$cur_operand_str $subst_cur_operand\n";
			$last_operand=$cur_operand;
		}
	}
	return $grep_var_ret_str;
}
