#!/usr/bin/perl
# Look for references to string constants

use strict;
use warnings;

my ($data, $start, $end);
open DAT, "rodata" or die;
while (<DAT>) {
  next unless /^\s*[0-9a-fA-F]+\s/;
  my @line = split " ", substr($_,0,45);
  if (!defined $start) {
    $start = hex $line[0];
  }
  shift @line;
  foreach (@line) {
    $data .= pack "H*", $_;
  }
}
close DAT;
die unless defined $start;
$end = $start + length($data);

while (<>) {
  for my $num (/(0x[0-9a-fA-F]+)/g) {
    my $pos = hex $num;
    next unless $pos >= $start && $pos < $end;
    my $str = unpack "Z*", substr($data, $pos-$start);
    $str =~ s/([\x00-\x1f"\\\x7f-\xff])/sprintf "\\x%02x", ord $1/eg;
    s/$/  ; "$str"/;
  }
  print;
}

